(* Les bibliotheques de base *)

#open "mec";;
#open "rules_ml";;

let Zc = "../zrun ../zc >/dev/null";;
let Zflags = "-O none -I .";;

let Lib_intf =
  ["bool.zi"; "cchar.zi"; "cstring.zi";
   "cvect.zi"; "eq.zi"; "exc.zi"; "fchar.zi"; "fstring.zi";
   "fvect.zi"; "float.zi"; "hash.zi"; "int.zi"; "io.zi"; "list.zi"; "obj.zi";
   "pair.zi"; "ref.zi"; "signal.zi"; "unix.zi";
   "handler.zi"; "lexing.zi"; "parsing.zi"; "sort.zi"; "thread.zi"]
;;

let Lib_impl =
  ["cchar.zo"; "cstring.zo"; "cvect.zo"; "eq.zo"; "exc.zo"; "fchar.zo";
   "fstring.zo"; "fvect.zo"; "hash.zo"; "io.zo"; "list.zo"; "pair.zo";
   "signal.zo"; "handler.zo"; "lexing.zo"; "parsing.zo"; "sort.zo"]
;;
   

rule "all" (Lib_intf @ Lib_impl) [];;

let clean = [command (["rm -f"] @ Lib_intf @ Lib_impl)];;
force "clean" [] clean;;
force "scratch" [] clean;;

rules_ml__default [Zc; Zflags];;

dep "cchar.zi" [];;
dep "cchar.zo" ["exc.zi"; "fchar.zi"; "int.zi"; "cchar.zi"];;
dep "cstring.zi" [];;
dep "cstring.zo" ["exc.zi"; "fstring.zi"; "int.zi"; "cstring.zi"];;
dep "cvect.zi" [];;
dep "cvect.zo" ["exc.zi"; "fvect.zi"; "int.zi"; "cvect.zi"];;
dep "eq.zi" [];;
dep "eq.zo" ["bool.zi"; "eq.zi"];;
dep "exc.zi" [];;
dep "exc.zo" ["exc.zi"];;
dep "fchar.zi" [];;
dep "fchar.zo" ["fstring.zi"; "int.zi"; "fchar.zi"];;
dep "fstring.zi" [];;
dep "fstring.zo" ["eq.zi"; "fchar.zi"; "int.zi"; "ref.zi"; "fstring.zi"];;
dep "fvect.zi" [];;
dep "fvect.zo" ["eq.zi"; "int.zi"; "list.zi"; "fvect.zi"];;
dep "handler.zi" [];;
dep "handler.zo" ["eq.zi"; "exc.zi"; "fvect.zi"; "int.zi"; "io.zi"; "obj.zi"; "unix.zi"; "handler.zi"];;
dep "hash.zi" [];;
dep "hash.zo" ["hash.zi"];;
dep "io.zi" ["unix.zi"];;
dep "io.zo" ["eq.zi"; "exc.zi"; "float.zi"; "fstring.zi"; "int.zi"; "unix.zi"; "io.zi"];;
dep "lexing.zi" ["io.zi"; "obj.zi"];;
dep "lexing.zo" ["exc.zi"; "fstring.zi"; "int.zi"; "io.zi"; "obj.zi"; "lexing.zi"];;
dep "list.zi" [];;
dep "list.zo" ["eq.zi"; "exc.zi"; "int.zi"; "list.zi"];;
dep "pair.zi" [];;
dep "pair.zo" ["exc.zi"; "pair.zi"];;
dep "parsing.zi" ["lexing.zi"; "obj.zi"];;
dep "parsing.zo" ["eq.zi"; "exc.zi"; "fvect.zi"; "int.zi"; "lexing.zi"; "obj.zi"; "ref.zi"; "parsing.zi"; "iparsing.zi"];;
dep "printf.zi" [];;
dep "printf.zo" ["obj.zi"; "printf.zi"];;
dep "ref.zi" [];;
dep "ref.zo" ["int.zi"; "ref.zi"];;
dep "signal.zi" [];;
dep "signal.zo" ["exc.zi"; "signal.zi"];;
dep "sort.zi" [];;
dep "sort.zo" ["sort.zi"];;

match get_args []
with [] -> build rules "all"
   | [targ] -> build rules targ
   | targs -> do_list (build rules) targs
;;
