#open "exc";;

let rec split = function
         []    -> [],[]
  | (x1,x2)::l -> let (l1,l2) = split l in (x1::l1,x2::l2)
;;

let rec combine = function
        [],[]     -> []
  | h1::t1,h2::t2 -> (h1,h2)::combine (t1,t2)
  |       _        -> failwith "combine"
;;

let map2 f =
  map where rec map = fun
    [] [] -> []
  | (h1::t1) (h2::t2) -> f h1 h2 :: map t1 t2
  | _ _ -> invalid_arg "map2"
;;

let do_list2 f =
  dol where rec dol = fun
    [] [] -> ()
  | (h1::t1) (h2::t2) -> f h1 h2; dol t1 t2
  | _ _ -> invalid_arg "do_list2"
;;

let map2_uncurry f =
  map where rec map = function
    [], [] -> []
  | h1::t1, h2::t2 -> f (h1,h2) :: map (t1,t2)
  | _ -> invalid_arg "map2_uncurry"
;;

let do_list2_uncurry f =
  dol where rec dol = function
    [], [] -> ()
  | h1::t1, h2::t2 -> f (h1,h2); dol (t1,t2)
  | _ -> invalid_arg "do_list2_uncurry"
;;

let it_list2 f =
  itl where rec itl a = fun
    [] [] -> a
  | (h1::t1) (h2::t2) -> itl (f a h1 h2) t1 t2
  | _ _ -> invalid_arg "it_list2"
;;

let list_it2 f l1 l2 a =
  lit l1 l2
  where rec lit = fun
    [] [] -> a
  | (h1::t1) (h2::t2) -> f h1 h2 (lit t1 t2)
  | _ _ -> invalid_arg "list_it2"
;;

