#open "obj";;

let output_int_hexa oc n =
  let s = create_string 8 in
  let rec fill n i =
    let digit = land n 15
    and rest  = land (lshift_right n 4) 4095 in
      set_nth_char s i (char_of_int(if digit < 10 then 48 + digit
                                                  else 87 + digit));
      if rest == 0 then i else fill rest (i-1) in
  let size = fill n 7 in
    output oc s size (8-size)
;;

let rec eat'em_all _ = magic eat'em_all
;;

let fprintf oc format =
  let rec do_printf i =
    if i >= string_length format then magic eat'em_all else
      match nth_char format i with
        `%` ->
           begin match nth_char format (succ i) with
             `%` -> output_char oc `%`;
                    do_printf(i+2)
           | `d` -> magic(fun x -> output_string oc (string_of_int x);
                                   do_printf (i+2))
           | `s` -> magic(fun x -> output_string oc x;
                                   do_printf (i+2))
           | `f` -> magic(fun x -> output_string oc (string_of_float x);
                                   do_printf (i+2))
           | `c` -> magic(fun x -> output_char oc x;
                                   do_printf (i+2))
           | `x` -> magic(fun x -> output_int_hexa oc x;
                                   do_printf (i+2))
           |  c  -> failwith ("printf: unknown format %" ^ char_for_read c)
           end
      |  c  -> output_char oc c; do_printf (succ i)
  in do_printf 0
;;

let printf = fprintf std_out
;;

let fprint = output_string
and print = output_string std_out
;;
