(* thread.mli *)

type process;;

value fork : (unit -> 'a) -> process             = 1 "thread_fork" "alloc"
  and exit : unit -> 'a                          = 1 "thread_exit"
  and join : process -> unit                     = 1 "thread_join" "alloc"
  and detach : process -> unit                   = 1 "thread_detach"
  and yield : unit -> unit                       = 1 "thread_yield"
  and self : unit -> process                     = 1 "mlthread_self" "alloc"
;;

type mutex;;
type condition;;

value new_mutex : unit -> mutex                  = 1 "thread_new_mutex" "alloc"
  and new_condition : unit -> condition      = 1 "thread_new_condition" "alloc"
  and lock : mutex -> unit                       = 1 "thread_lock" "alloc"
  and unlock : mutex -> unit                     = 1 "thread_unlock"
  and try_lock : mutex -> bool                   = 1 "thread_try_lock"
  and signal : condition -> unit                 = 1 "thread_signal"
  and broadcast : condition -> unit              = 1 "thread_broadcast"
  and wait : condition -> mutex -> unit          = 2 "thread_wait" "alloc"
;;
