.TH CAMLRUN 1 "Tue Aug 13"  

.SH NAME
camlrun \- The CAML Light runtime system and bytecode interpreter

.SH SYNOPSIS
.B camlrun
[
.B \-v
]
[
.BI \-mhgsar \ size-in-kilobytes
]
.I bytecode-file
.I arguments ...

.SH DESCRIPTION

.B camlrun
executes a bytecode file, as produced by the linking phase of the
camlc(1) compiler. Most of the time, bytecode files are scripts that
are executable, and manage to launch
.B camlrun
by themselves. In some cases, the user may have to invoke
.B camlrun
by hand, to gain access to the bytecode interpreter options, or when
bytecode files fail to execute due to a non-standard installation.

The first non-option argument on the command line is taken to be the
name of the bytecode file to run. The remaining arguments on the
command line are directly passed to the CAML Light program.

.SH OPTIONS
.TP
.B \-v
Verbose mode. When set, the memory allocator and garbage collector
prints various diagnostic messages on error output.
.TP
.BI \-m size
Set the total memory size allocated to the runtime system (in
kilobytes). Meaningful only on non-Unix machines. (On most Unix
machines, the runtime system dynamically grows this size during
program execution, and therefore this option is meaningless.)
.TP
.BI \-hgsar size
Set the initial sizes of various memory zones (in kilobytes). All
these zones will be dynamically resized when needed. The zones are: the
heap (\-h); the generation (\-g); the static zone (\-s); the argument
stack (\-a); the return stack (\-r).


