/* fail.c */

#include "control.h"
#include "fail.h"
#include "memory.h"
#include "mlvalues.h"
#include "private.h"

void mlraise(v)
     value v;
{
  exn_bucket = v;
  longjmp(*external_raise, 1);
}

static void raise_with_arg(tag, arg)
     tag_t tag;
     value arg;
{
  value bucket;
  Push_roots (a, 1);
  a [0] = arg;

  bucket = alloc_small_unshr(2, tag);
  Field(bucket, 0) = a [0];
  Pop_roots ();
  mlraise(bucket);
}

static void raise_with_string(tag, msg)
     unsigned int tag;
     char * msg;
{
  value str;

  str = alloc_string (msg);
  raise_with_arg (tag, str);
}

void failwith (msg)
     char * msg;
{
  raise_with_string(Failure_exn, msg);
}

void invalid_argument (msg)
     char * msg;
{
  raise_with_string(Invalid_exn, msg);
}

void raise_out_of_memory()
{
  mlraise(Atom(Out_of_memory_exn));
}

void os_error()
{
  extern int errno;
  raise_with_arg(Os_exn, Val_long(errno));
}
