/* floats.c */

#include <math.h>
#include "mlvalues.h"
#include "fail.h"

#ifndef NO_ECVT

char * convert_float(number, ndigit, buf)
     double number;
     int ndigit;
     char *buf;
{
  int sign, decpt;
  register char *p1, *p2;
  register i;
  extern char * ecvt();
  
  p1 = ecvt(number, ndigit, &decpt, &sign);
  p2 = buf;
  if (sign) *p2++ = '-';
  for (i=ndigit-1; i>0 && p1[i]=='0'; i--)
    ndigit--;
  if (decpt >= 0 && decpt-ndigit > 4
      || decpt < 0 && decpt < -3) { /* use E-style */
    decpt--;
    *p2++ = *p1++;
    *p2++ = '.';
    for (i=1; i<ndigit; i++)
      *p2++ = *p1++;
    *p2++ = 'e';
    if (decpt<0) {
      decpt = -decpt;
      *p2++ = '-';
    } else
      *p2++ = '+';
    if (decpt >= 100) {
      *p2++ = decpt/100 + '0';
      decpt = decpt%100;
    }
    *p2++ = decpt/10 + '0';
    *p2++ = decpt%10 + '0';
  } else {
    if (decpt<=0) {
      if (*p1!='0')
        *p2++ = '.';
      while (decpt<0) {
        decpt++;
        *p2++ = '0';
      }
    }
    for (i=1; i<=ndigit; i++) {
      *p2++ = *p1++;
      if (i==decpt)
        *p2++ = '.';
    }
    if (ndigit<decpt) {
      while (ndigit++<decpt)
        *p2++ = '0';
      *p2++ = '.';
    }
  }
  *p2 = '\0';
  return(buf);
}

value string_of_float(f)  /* ML */
     value f;
{
#define Nbr_digits 15           /* A revoir */

  char buff[Nbr_digits+25];

  convert_float(Double_val(f), Nbr_digits, buff);
  return alloc_string(buff);
}

#else /* NO_ECVT */

value string_of_float(f)
     value f;
{
  char buff[256];           /* A revoir */

  sprintf(buff, "%g", Double_val(f));
  return alloc_string(buff);
}

#endif /* NO_ECVT */

value float_of_string(s)        /* ML */
     value s;
{
  extern double atof();
  return alloc_double(atof(String_val(s)));
}

value exp_float(f)              /* ML */
     value f;
{
  return alloc_double(exp(Double_val(f)));
}

value log_float(f)              /* ML */
     value f;
{
  return alloc_double(log(Double_val(f)));
}

value sqrt_float(f)             /* ML */
     value f;
{
  return alloc_double(sqrt(Double_val(f)));
}

value power_float(f, g)         /* ML */
     value f, g;
{
  return alloc_double(pow(Double_val(f), Double_val(g)));
}

value sin_float(f)              /* ML */
     value f;
{
  return alloc_double(sin(Double_val(f)));
}

value cos_float(f)              /* ML */
     value f;
{
  return alloc_double(cos(Double_val(f)));
}

value tan_float(f)              /* ML */
     value f;
{
  return alloc_double(tan(Double_val(f)));
}

value asin_float(f)             /* ML */
     value f;
{
  return alloc_double(asin(Double_val(f)));
}

value acos_float(f)             /* ML */
     value f;
{
  return alloc_double(acos(Double_val(f)));
}

value atan_float(f)             /* ML */
     value f;
{
  return alloc_double(atan(Double_val(f)));
}

value atan2_float(f, g)        /* ML */
     value f, g;
{
  return alloc_double(atan2(Double_val(f), Double_val(g)));
}
