/* freelist.h */

/* Free lists of heap blocks. */

#ifndef _freelist_
#define _freelist_


#include "control.h"
#include "mlvalues.h"

typedef unsigned char **free_list_t;

typedef struct {
  int avail;
  mutex_t mu;
  unsigned char *lists [Num_small_fl];
  int tail;
  int head;
} small_fl_t;

extern small_fl_t small_fl [4];

#ifdef ANSI
extern free_list_t fl_new (void);
extern void fl_free (free_list_t);
extern value fl_allocate (free_list_t, mlsize_t);
extern value list_allocate (unsigned char **, mlsize_t);
#else /* ANSI */
free_list_t fl_new ();
void fl_free ();
value fl_allocate ();
value list_allocate ();
#endif /* ANSI */


#endif /* _freelist_ */
