/* ints.c */

#include "debugger.h"
#include "fail.h"
#include "mlvalues.h"

#define Itoa_buffer_size (3 * sizeof (long) + 2)

unsigned char *itoa (buf, num)
     unsigned char buf [Itoa_buffer_size];
     long num;
{
  unsigned char * i;
  unsigned long n;

  i = buf + Itoa_buffer_size - 1;
  *i = '\0';
  if (num < 0) n = -num; else n = num;
  do {
    *--i = n % 10 + '0';
    n = n / 10;
  } while (n > 0);
  if (num < 0) *--i = '-';
  return i;
}

value string_of_int(i)          /* ML */
     value i;
{
  unsigned char buff [Itoa_buffer_size];
  unsigned char * p;
  int n;
  value res;

  p = itoa(buff, (int) Long_val(i));
  return alloc_string(p);
}

value int_of_string(s)          /* ML */
     value s;
{
  long res;
  int sign;
  char * p;

  p = String_val(s);
  if (*p == '-') {
    sign = -1;
    p++;
  } else {
    sign = 1;
  }
  for (res = 0; *p >= '0' && *p <= '9'; p++) {
    res = 10 * res + *p - '0';
  }
  if (*p != 0) failwith("int_of_string");
  return Val_long(sign < 0 ? -res : res);
}
