/* io.h : entrees/sorties bufferisees */

#ifndef _io_
#define _io_

#include "control.h"

/* Structure des descripteurs */

#ifndef Io_buffer_size
#define Io_buffer_size 8192
#endif

struct channel {
  struct mutex mutex;           /* Pour eviter les modifs. concurrentes */
  int fd;	                /* Descripteur de fichier Unix */
  long offset;                  /* Offset du buffer ds le fichier Unix */
  unsigned char * curr;         /* Position courante dans le buffer */
  unsigned char * max;          /* Fin logique du buffer */
  unsigned char * end;          /* Fin physique du buffer */
  unsigned char buff[Io_buffer_size]; /* Le buffer lui-meme */
};

/* Pour un buffer en ecriture:
     offset est la position absolue du debut du buffer (buff).
   Pour un buffer en lecture:
     offset est la position absolue de la fin du buffer (max).  */

#ifdef ANSI

extern void putword(struct channel *, long);
extern void putblock(struct channel *, value, long, long);
extern long getword(struct channel *);
extern long getblock(struct channel *, value, long, long);

#else

extern void putword();
extern void putblock();
extern long getword();
extern long getblock();

#endif


#endif /* _io_ */
