/* mem_misc.h */

/* Miscellaneous macros and variables. */

#ifndef _misc_
#define _misc_


#ifndef NULL
#define NULL 0
#endif

typedef unsigned char uchar;
typedef char * char_ptr;

extern int verb_gc;

#ifdef ANSI
extern void gc_message (char *, unsigned long, char *);
extern void gc_message_str (char *);
extern void fatal_error (char *);
extern void fatal_unix_error (char *, char *);
extern void memmov (uchar *, uchar *, unsigned long);
extern uchar *aligned_malloc (unsigned long, long);
#else
void gc_message ();
void gc_message_str ();
void fatal_error ();
void fatal_unix_error ();
void memmov ();
uchar *aligned_malloc ();
#endif /* ANSI */


#endif /* _misc_ */
