/* roots.c */

#include "stacks.h"
#include "private.h"
#include "mem_misc.h"

/* This function MUST NOT change any of the private data, because it will
   sometimes be called by the GC thread with the private data stolen from a
   mutator thread. */
void local_roots (trace_fn)
     void (*trace_fn) ();
{
  register value *sp;
  register int i;

  /* la pile d'arguments */
  for (sp = extern_asp; sp < arg_stack_high; sp++) {

    if (*sp != Mark) trace_fn (sp);
  }

  /* la pile de retour */
  for (sp = extern_rsp; sp < ret_stack_high; ) {
    trace_fn(&(((struct return_frame *) sp)->env));
    i = ((struct return_frame *) sp)->cache_size;
    sp = (value *) ((char *) sp + sizeof(struct return_frame));
    while (i > 0) {
      trace_fn (sp);
      sp++;
      i--;
    }
  }

  /* les racines C */
  {
    value *block;
    for (block = c_roots_head; block != NULL; block = (value *) block [1]){
      for (sp = block - (long) block [0]; sp < block; sp++){
	trace_fn (sp);
      }
    }
  }
  /* les donnees attachees au thread courant */
  trace_fn(&per_thread_data);
}
