/* semaph.c */

#include "control.h"
#include "semaph.h"

void sem_init (sem)
     semaphore_t sem;
{
  mutex_init (&sem->mu);
  condition_init (&sem->c);
  sem->count = 0;
}

void sem_clear (sem)
     semaphore_t sem;
{
  mutex_clear (&sem->mu);
  condition_clear (&sem->c);
}

semaphore_t sem_alloc ()
{
  semaphore_t result;

  result = (semaphore_t) malloc (sizeof (struct semaphore));
  sem_init (result);
  return result;
}

void sem_free (sem)
     semaphore_t sem;
{
  sem_clear (sem);
  free (sem);
}

void sem_P (sem)
     semaphore_t sem;
{
  mutex_lock (&sem->mu);{
    while (sem->count == 0) condition_wait (&sem->c, &sem->mu);
    --sem->count;
  }mutex_unlock (&sem->mu);
}

int sem_try_P (sem)
     semaphore_t sem;
{
  int result;

  mutex_lock (&sem->mu);{
    if (sem->count != 0){
      --sem->count;
      result = 1;
    }else{
      result = 0;
    }
  }mutex_unlock (&sem->mu);
  return result;
}

void sem_V (sem)
     semaphore_t sem;
{
  mutex_lock (&sem->mu);{
    ++sem->count;
  }mutex_unlock (&sem->mu);
  condition_signal (&sem->c);
}
