/* semaph.h */

#ifndef _semaph_
#define _semaph_


#include "control.h"

typedef struct semaphore {
  struct mutex mu;
  struct condition c;
  unsigned long count;
} *semaphore_t;

#ifdef ANSI
extern semaphore_t sem_alloc (void);
extern void sem_free (semaphore_t);
extern void sem_init (semaphore_t);
extern void sem_clear (semaphore_t);
extern void sem_P (semaphore_t);
extern int sem_try_P (semaphore_t);
extern void sem_V (semaphore_t);
#else /* ANSI */
semaphore_t sem_alloc ();
void sem_free ();
void sem_init ();
void sem_clear ();
void sem_P ();
int sem_try_P ();
void sem_V ();
#endif /* ANSI */


#endif /* _semaph_ */
