/* Lecture d'un mot 16 bits, 32 bits, non aligne */

#ifndef _unaligned
#define _unaligned


#include "mem_misc.h"

#ifdef ALIGNMENT
#ifdef BIG_ENDIAN

#define s16(p) ((((schar *) (p))[0] << 8) + ((uchar *) (p))[1])
#define u16(p) ((((uchar *) (p))[0] << 8) + ((uchar *) (p))[1])
#define s32(p) ((((schar *) (p))[0] << 24) + (((uchar *) (p))[1] << 16) \
               + (((uchar *) (p))[2] << 8) + ((uchar *) (p))[3])
#define u32(p) ((((uchar *) (p))[0] << 24) + (((uchar *) (p))[1] << 16) \
               + (((uchar *) (p))[2] << 8) + ((uchar *) (p))[3])

#define store32(p,w) {                                                        \
  (p)[0] = (w) >> 24;                                                         \
  (p)[1] = (w) >> 16;                                                         \
  (p)[2] = (w) >> 8;                                                          \
  (p)[3] = (w); }

#else /* BIG_ENDIAN */

#define s16(p) ((((schar *) (p))[1] << 8) + ((uchar *) (p))[0])
#define u16(p) ((((uchar *) (p))[1] << 8) + ((uchar *) (p))[0])
#define s32(p) ((((schar *) (p))[3] << 24) + (((uchar *) (p))[2] << 16) \
               + (((uchar *) (p))[1] << 8) + ((uchar *) (p))[0])
#define u32(p) ((((uchar *) (p))[3] << 24) + (((uchar *) (p))[2] << 16) \
               + (((uchar *) (p))[1] << 8) + ((uchar *) (p))[0])

#define store32(p,w) {                                                        \
  (p)[0] = (w);                                                               \
  (p)[1] = (w) >> 8;                                                          \
  (p)[2] = (w) >> 16;                                                         \
  (p)[3] = (w) >> 24; }

#endif /* BIG_ENDIAN */
#else /* ALIGNMENT */

#define s16(p) (* (short *) (p))
#define u16(p) (* (unsigned short *) (p))
#define s32(p) (* (long *) (p))
#define u32(p) (* (unsigned long *) (p))
#define store32(p,w) { (*(long *)(p)) = (w); }

#endif /* ALIGNMENT */


#endif /* _unalignd_ */
