#open "const";;
#open "hashtbl";;
#open "unix";;

type 'a numtable =
  { mutable num_cnt: int;               (* Le compteur courant *)
    num_tbl: ('a * int) hashtable }     (* La table *)
;;

let find_in_numtable nt =
  find_in_assoctable nt.num_tbl
;;

let ic = open_in unix__command_line.(1) in
  while input_char ic != `\010` do () done;
  let pos1 = pos_in ic in
  let size_code = input_int ic in
  let size_data = input_int ic in
  let size_symb = input_int ic in
  let size_debug = input_int ic in
    let pos2 = pos_in ic + size_code + size_data in
    seek_in ic pos2;
    print_string "Reading linker tables..."; print_newline();
    let global_table = (input_value ic : qualified_ident numtable) in 
(*
    let exn_tag_table = (input_value ic : qualified_ident numtable) in 
    let tag_exn_table = (input_value ic : qualified_ident vect) in 
*)
    close_in ic;
    begin try
      print_int(find_in_numtable global_table
                 {qual = unix__command_line.(2); id = unix__command_line.(3)})
    with failure "find" ->
      print_string "Not found"
    end;
    print_newline();
    exit 0
;;
