type qualified_ident =
  { qual: string;
    id: string }
;;

type constr_tag =
    ConstrExtensible of qualified_ident (* le nom du constructeur *)
  | ConstrRegular of int * int  (* le tag du constr & l'etendue du type *)
;;

type atomic_constant =
    ACint of int
  | ACfloat of float
  | ACstring of string
  | ACchar of char

and struct_constant =
    SCatom of atomic_constant
  | SCblock of constr_tag * struct_constant list
;;

value int_of_atom : atomic_constant -> int;;
value int_of_constr_tag : constr_tag -> int;;
