#open "globals";;
#open "hashtbl";;

type module =
  { mod_name: string;                          (* le nom *)
    mod_values: value_desc global hashtable;   (* la table des valeurs *)
    mod_constrs: constr_desc global hashtable; (* la table des constructeurs *)
    mod_labels: label_desc global hashtable;   (* la table des etiquettes *)
    mod_types: type_desc global hashtable }    (* la table des types *)
;;
value types_of_module : module -> type_desc global hashtable;;
value labels_of_module : module -> label_desc global hashtable;;
value constrs_of_module : module -> constr_desc global hashtable;;
value values_of_module : module -> value_desc global hashtable;;
value name_of_module : module -> string;;
value find_in_symtable : 'a global hashtable -> string -> 'a global;;
value remove_from_symtable : 'a global hashtable -> 'a global -> unit;;
value add_to_symtable : 'a global hashtable -> 'a global -> unit;;
value module_table : (string * module) hashtable;;
value new_module : string -> module;;
value path_interfaces : string list ref;;
value load_module : string -> module;;
value find_module : string -> module;;
value kill_module : string * module -> unit;;
value default_used_modules : string list ref;;
value type_stamp : int ref;;
value used_modules : module list ref;;
value defined_module : module ref;;
value new_globalenv : string -> unit;;
value compiled_module_name : unit -> string;;
value defined_global : string -> 'a -> 'a global;;
value new_type_stamp : unit -> int;;
value rollback_buffer : (unit -> unit) list ref;;
value reset_rollback : unit -> unit;;
value rollback : unit -> unit;;
value add_global_info : (module -> 'a global hashtable) -> 'a global -> unit;;
value add_type : type_desc global -> unit;;
value add_label : label_desc global -> unit;;
value add_constr : constr_desc global -> unit;;
value add_value : value_desc global -> unit;;
value find_desc : (module -> 'a global hashtable) -> global_reference -> 'a global;;
value find_type_desc : global_reference -> type_desc global;;
value find_label_desc : global_reference -> label_desc global;;
value find_constr_desc : global_reference -> constr_desc global;;
value find_value_desc : global_reference -> value_desc global;;
value write_compiled_interface : out_channel -> unit;;
