(* readword.ml: pour lire un fichier mot par mot et renvoyer la liste
   des chaines lues *)

let input_words filename = 
  let ic = open_in filename in
  let buff = create_string 1024 in
  let rec readchars i =
    match input_char ic with
      ` ` | `\n` | `\r` | `\t` ->
        i
    | c ->
        if i < string_length buff then set_nth_char buff i c else c;
        readchars (succ i) in
  let rec readword () =
    match input_char ic with
      ` ` | `\n` | `\r` | `\t` ->
        readword()
    | c ->
        set_nth_char buff 0 c;
        sub_string buff 0 (readchars 1) in
  let rec readwords l =
    try
      readwords(readword() :: l)
    with End_of_file ->
      close_in ic; rev l in
  readwords []
;;
