(* reloc.ml : information de "relocation" du bytecode produit *)

#open "const";;
#open "buffcode";;

let reloc_info = ref ([] : (info * int) list);;

let reset () =
  reloc_info := []; ()
;;

let enter info =
  reloc_info := (info, get_abs_out_position()) :: !reloc_info
;;

let slot_for_literal sc =
  enter (Reloc_literal sc);
  out_short 0
and slot_for_get_global id =
  enter (Reloc_getglobal id);
  out_short 0
and slot_for_set_global id =
  enter (Reloc_setglobal id);
  out_short 0
and slot_for_tag id =
  enter (Reloc_tag id);
  out 0
;;

let get_info () =
  let res = !reloc_info in reloc_info := []; rev res
;;

