type t = {
    lock: thread__mutex;
    cond: thread__condition;
    mutable count: int
};;

let new () =
  { lock = thread__new_mutex();
    cond = thread__new_condition();
    count = 0 }
;;

let P sem =
  thread__lock(sem.lock);
  while sem.count == 0 do
    thread__wait sem.cond sem.lock
  done;
  sem.count <- pred sem.count;
  thread__unlock(sem.lock)
;;

let V sem =
  thread__lock(sem.lock);
  sem.count <- succ sem.count;
  thread__unlock(sem.lock);
  thread__signal(sem.cond)
;;
