/*------------------------------------------------------------------------------

NAME
      Touch -- change date of last modification of files

SYNOPSIS
      Touch file

DESCRIPTION
      For each file, "Touch" will open it, read the first byte,
	    rewrite this byte, and close the file. This ensures that the date
		of last modification is properly updated, even on bogus AppleShare
		servers such as Aufs.
		
NO COPYRIGHT
      This is public domain software written by Planar.

COMPILATION
	  Compile this file with the following commands :
	    C Touch.c
	    Link -c 'MPS ' -t MPST -o Touch Touch.c.o 
			    "{CLibraries}"StdCLib.o 
			    "{CLibraries}"CInterface.o 
			    "{CLibraries}"CRuntime.o 
			    "{Libraries}"Interface.o 
			    "{Libraries}"ToolLibs.o

------------------------------------------------------------------------------*/

#include <fcntl.h>
#include <stdio.h>
#include <ErrMgr.h>
#include <CursorCtl.h>
#include <Errors.h>


char	errorBuffer [256];
char	*usage = "# Usage - %s file\n";		

int main (int argc, char *argv [])
{
	long i;
	int  status;
	int  fd;
	char buf;

	status = 0;
	InitCursorCtl (NULL);

	for (i = 1; i < argc; i++) {
		fd = open (argv [i], O_RDWR);
		if (fd >= 0){
			read (fd, &buf, 1);
			lseek (fd, 0L, SEEK_SET);
			write (fd, &buf, 1);
			close (fd);
		}else{
			fprintf (stderr,"### %s - Unable to open file %s.\n", argv [0], argv [i]);
			fprintf (stderr,"# %s\n", GetSysErrText (MacOSErr, errorBuffer));
			status = 2;
		}
		RotateCursor (32);
	}
	return status;
}
