/* Compare two bytecode files.
   Same as the cmpcode script, but written in C for those who don't have
   tail and cmp. */

#include <stdio.h>

#ifdef __TURBOC__
char open_mode[] = "rb";
#else
char open_mode[] = "r";
#endif

void skip_header(f)
     register FILE * f;
{
  while(1)
    switch(getc(f)) {
    case '\012':
      return;
    case EOF:
      fprintf(stderr, "Corrupted bytecode file.\n");
      exit(2);
    }
}    

main(argc, argv)
     int argc;
     char * argv[];
{
  register FILE * f1, * f2;
  register char c1, c2;

  if (argc != 3) {
    fprintf(stderr, "Usage: cmpcode <file1> <file2>\n");
    return 2;
  }
  f1 = fopen(argv[1], open_mode);
  if (f1 == NULL) {
    perror(argv[1]);
    return 2;
  }
  f2 = fopen(argv[2], open_mode);
  if (f2 == NULL) {
    perror(argv[2]);
    return 2;
  }
  skip_header(f1);
  skip_header(f2);
  do {
    c1 = getc(f1);
    c2 = getc(f2);
    if (c1 != c2) {
      fclose(f1);
      fclose(f2);
      printf("%s and %s differ.\n", argv[1], argv[2]);
      return 1;
    }
  } while (c1 != EOF);
  fclose(f1);
  fclose(f2);
  printf("%s and %s are identical.\n", argv[1], argv[2]);
  return 0;
}
