let buffer1 = prodcons__new 11 ("", 0)
and buffer2 = prodcons__new 13 ("", 0)
;;

let rec read_task inchan sz () =
  let b = create_string sz in
  let n = input inchan b 0 sz in
    prodcons__put buffer1 (b,n);
    if n > 0 then read_task inchan sz ()
;;

let rec silly_task () =
  let (b,n) = prodcons__get buffer1 in
    prodcons__put buffer2 (b,n);
    if n > 0 then silly_task ()
;;

let rec write_task outchan () =
  let (b,n) = prodcons__get buffer2 in
  if n > 0 then begin
    output outchan b 0 n;
    write_task outchan ()
  end
;;

let inchan = open_in unix__command_line.(1)
and outchan = open_out unix__command_line.(2)
and sz =
  if vect_length unix__command_line >= 4
  then int_of_string unix__command_line.(3)
  else 4096 in
let read_pid = thread__fork (read_task inchan sz)
and silly_pid = thread__fork (silly_task)
and write_pid = thread__fork (write_task outchan) in
thread__join read_pid;
thread__join silly_pid;
thread__join write_pid;
close_in inchan;
close_out outchan;
exit 0
;;
