type 'a t =
   Sentinel of mutable 'a t * mutable 'a t
 | Element of mutable 'a t * mutable 'a t * 'a
;;
exception Empty;;

let new () =
  let rec result = Sentinel (result, result)
  in result
;;

let set1 e1 e2 =
  match e1
  with Sentinel (x, _) -> (x <- e2)
     | Element (x, _, _) -> (x <- e2)
;;

let set2 e1 e2 =
  match e1
  with Sentinel (_, x) -> (x <- e2)
     | Element (_, x, _) -> (x <- e2)
;;

let put1 q x =
  match q
  with Sentinel (e, _) -> let ne = Element (e, q, x)
                          in set2 e ne; e <- ne; ()
     | _ -> failwith "dequeue__put1"
;;

let put2 q x =
  match q
  with Sentinel (_, e) -> let ne = Element (q, e, x)
                          in set1 e ne; e <- ne; ()
     | _ -> failwith "dequeue__put2"
;;

let get1 q =
  match q
  with Sentinel ((Element (e, _, x) as e1), _)
         -> let x = x and e = e in e1 <- e; set2 e q; x
     | _ -> raise Empty
;;

let get2 q =
  match q
  with Sentinel (_, (Element (_, e, x) as e1))
         -> let x = x and e = e in e1 <- e; set1 e q; x
     | _ -> raise Empty
;;
