type t = {lock : thread__mutex; cond : thread__condition; mutable v : bool};;

let new () =
  {lock = thread__new_mutex ();
   cond = thread__new_condition ();
   v = false}
;;

let signal {lock = l; cond = c; v = v} =
  thread__lock l;
  v <- true;
  thread__unlock l;
  thread__signal c
;;

let wait {lock = l; cond = c; v = v} =
  thread__lock l;
  while not v
  do thread__wait c l
  done;
  v <- false;
  thread__unlock l
;;
