(* lifo.ml *)

(* LIFO implementation of queues (interface queue.mli). *)

type 'a t =
  Ref of mutable 'a list
;;

let new () = Ref [];;

let reset (Ref l) = (l <- []); ();;

let put (Ref l) val = (l <- val::l); ();;

let get = function
   Ref [] -> raise Empty
 | Ref (x::t as l) -> let x = x in (l <- t); x
;;

let length (Ref l) = list_length l;;

let is_empty = function
   Ref [] -> true
 | _ -> false
;;
