(* alloc.ml *)

let m = int_of_string (unix__command_line.(1));;

let error msg = (prerr_string msg; unix__exit 2);;

let rec verif id l n =
  match l
  with [] -> if n <> (m + 1)
             then error "Short."
             else print_string "Good."
     | (id1, n1)::t
         -> if n1 <> n or id1 <> id
            then error "Wrong."
            else verif id t (n + 1)
;;

let rec worker id l n =
  if n < 0
  then verif id l 0
  else worker id ((id, n)::l) (n - 1)
;;

let rec launch l i =
  if i = 0 then l
  else launch (thread__fork (fun () -> worker i [] m)::l) (i - 1)
;;

let rec catch = function
   [] -> ()
 | p::t -> thread__join p; catch t
;;

catch (launch [] 8);;
print_endline "";;
flush std_out;;
